Add the diff option --no-defaults
[git/dscho.git] / git-repack.sh
blob0868734723b3c96144bfa9360a9e19ebae1995f7
1 #!/bin/sh
3 # Copyright (c) 2005 Linus Torvalds
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git repack [options]
9 --
10 a pack everything in a single pack
11 A same as -a, and turn unreachable objects loose
12 d remove redundant packs, and run git-prune-packed
13 f pass --no-reuse-object to git-pack-objects
14 n do not run git-update-server-info
15 q,quiet be quiet
16 l pass --local to git-pack-objects
17 Packing constraints
18 window= size of the window used for delta compression
19 window-memory= same as the above, but limit memory size instead of entries count
20 depth= limits the maximum delta depth
21 max-pack-size= maximum size of each packfile
23 SUBDIRECTORY_OK='Yes'
24 . git-sh-setup
26 no_update_info= all_into_one= remove_redundant= unpack_unreachable=
27 local= quiet= no_reuse= extra=
28 while test $# != 0
30 case "$1" in
31 -n) no_update_info=t ;;
32 -a) all_into_one=t ;;
33 -A) all_into_one=t
34 unpack_unreachable=--unpack-unreachable ;;
35 -d) remove_redundant=t ;;
36 -q) quiet=-q ;;
37 -f) no_reuse=--no-reuse-object ;;
38 -l) local=--local ;;
39 --max-pack-size|--window|--window-memory|--depth)
40 extra="$extra $1=$2"; shift ;;
41 --) shift; break;;
42 *) usage ;;
43 esac
44 shift
45 done
47 case "`git config --bool repack.usedeltabaseoffset || echo true`" in
48 true)
49 extra="$extra --delta-base-offset" ;;
50 esac
52 PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
53 PACKTMP="$GIT_OBJECT_DIRECTORY/.tmp-$$-pack"
54 rm -f "$PACKTMP"-*
55 trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
57 # There will be more repacking strategies to come...
58 case ",$all_into_one," in
59 ,,)
60 args='--unpacked --incremental'
62 ,t,)
63 args= existing=
64 if [ -d "$PACKDIR" ]; then
65 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
66 | sed -e 's/^\.\///' -e 's/\.pack$//'`
68 if [ -e "$PACKDIR/$e.keep" ]; then
69 : keep
70 else
71 existing="$existing $e"
73 done
74 if test -n "$existing" -a -n "$unpack_unreachable" -a \
75 -n "$remove_redundant"
76 then
77 args="$args $unpack_unreachable"
81 esac
83 args="$args $local $quiet $no_reuse$extra"
84 names=$(git pack-objects --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
85 exit 1
86 if [ -z "$names" ]; then
87 if test -z "$quiet"; then
88 echo Nothing new to pack.
92 # Ok we have prepared all new packfiles.
93 mkdir -p "$PACKDIR" || exit
95 # First see if there are packs of the same name and if so
96 # if we can move them out of the way (this can happen if we
97 # repacked immediately after packing fully.
98 rollback=
99 failed=
100 for name in $names
102 for sfx in pack idx
104 file=pack-$name.$sfx
105 test -f "$PACKDIR/$file" || continue
106 rm -f "$PACKDIR/old-$file" &&
107 mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
108 failed=t
109 break
111 rollback="$rollback $file"
112 done
113 test -z "$failed" || break
114 done
116 # If renaming failed for any of them, roll the ones we have
117 # already renamed back to their original names.
118 if test -n "$failed"
119 then
120 rollback_failure=
121 for file in $rollback
123 mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
124 rollback_failure="$rollback_failure $file"
125 done
126 if test -n "$rollback_failure"
127 then
128 echo >&2 "WARNING: Some packs in use have been renamed by"
129 echo >&2 "WARNING: prefixing old- to their name, in order to"
130 echo >&2 "WARNING: replace them with the new version of the"
131 echo >&2 "WARNING: file. But the operation failed, and"
132 echo >&2 "WARNING: attempt to rename them back to their"
133 echo >&2 "WARNING: original names also failed."
134 echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
135 for file in $rollback_failure
137 echo >&2 "WARNING: old-$file -> $file"
138 done
140 exit 1
143 # Now the ones with the same name are out of the way...
144 fullbases=
145 for name in $names
147 fullbases="$fullbases pack-$name"
148 chmod a-w "$PACKTMP-$name.pack"
149 chmod a-w "$PACKTMP-$name.idx"
150 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
151 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" ||
152 exit
153 done
155 # Remove the "old-" files
156 for name in $names
158 rm -f "$PACKDIR/old-pack-$name.idx"
159 rm -f "$PACKDIR/old-pack-$name.pack"
160 done
162 # End of pack replacement.
164 if test "$remove_redundant" = t
165 then
166 # We know $existing are all redundant.
167 if [ -n "$existing" ]
168 then
169 ( cd "$PACKDIR" &&
170 for e in $existing
172 case " $fullbases " in
173 *" $e "*) ;;
174 *) rm -f "$e.pack" "$e.idx" "$e.keep" ;;
175 esac
176 done
179 git prune-packed $quiet
182 case "$no_update_info" in
183 t) : ;;
184 *) git update-server-info ;;
185 esac